#!/usr/bin/perl

use strict;
if ($#ARGV < 0) {
  print "Use:\tperl $0 ajdmatfile\n";
  print "Goal:\tFrom an adjacent matrix to a list of edges in the \"spm\" format\n";
  exit(0);
}

open(ADJ, "<$ARGV[0]") or die "File \"$ARGV[0]\" opening problem\n";
my $nbedges = 0;
my $i=0;
my @spm=();
while (my $l=<ADJ>){
  chomp($l);
  $l =~ s/ //gi;
  #if ($l=~/^[01]+$/){

    while ( $l =~ /1/gi ){
      my $j = (pos $l)-1;
      push(@spm, "$i $j");
      $nbedges++;
    }
    $i++

  #}
}
close(ADJ);

foreach my $edge(sort{$a<=>$b}(@spm)){
  print "$edge\n";
}
print STDERR "$nbedges edges between $i vertices\n";
