#!/usr/bin/perl

# Copyright (C) 2006 Laboratoire Statistique & G^[-b-bnome^[-A-A
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# Authors:
# Vincent Miele, Franck Picard
# 01/11/2006

use strict;
if ($#ARGV < 2) {
  print "Usage: perl $0 file_Qx.model\nOR\n";
  print "Usage: perl $0 file_Qx.model\n";
  exit(0);
}


########
open MODEL,"$ARGV[0]" or die "File \"$ARGV[0]\" opening problem\n";
# Q
my $Q;
my $l=<MODEL>;
$l=<MODEL>;
if ($l=~/^(\d+)$/){
  $Q=$1;
}
else{
  die "File \"$ARGV[0]\" format problem\n"
}
# Alpha
$l=<MODEL>;
$l=<MODEL>;
chomp($l);
my @al = split /\s+/, $l;
if (($#al+1)!=$Q){
  die "File \"$ARGV[0]\" format problem\n"
}
# Pi
$l=<MODEL>;
$l=<MODEL>;
my @pi=();
while ($l=~/^\d+/){
  chomp($l);
  my @li=split /\s+/, $l;
  if (($#li+1)!=$Q){
    die "File \"$ARGV[0]\" format problem\n";
  }
  push @pi, @li;
  $l=<MODEL>;
}
close MODEL;

########
my $E=0;
my ($numE, $denE);
my $E2=0;
my ($numE2, $denE2);
foreach my $q(0..($Q-1)){
  foreach my $l(0..($Q-1)){
    foreach my $m(0..($Q-1)){
      my $tmp = $al[$q]*$al[$l]*$al[$m]*$pi[$q*$Q+$l]*$pi[$q*$Q+$m];
      $numE+=$tmp*$pi[$l*$Q+$m];
      $denE+=$tmp;
    }
  }
}
