#!/usr/bin/perl

# Copyright (C) 2006 Laboratoire Statistique & G^[-b-bnome^[-A-A
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# Authors:
# Vincent Miele, Franck Picard
# 01/11/2006

use strict;
if ($#ARGV < 1) {
  print "Use:\tperl $0 file_Qx.model file_Qx.model\n";
  print "Goal:\tFrom \n";
  print "\tDisplay \n";
  exit(0);
}

my %classes=();
open(MODEL1, "<$ARGV[0]") or die "File \"$ARGV[0]\" opening problem\n";
my $l;
<MODEL1>;
my $Q = <MODEL1>;
chomp($Q);
while ($l!~/Tau/){
  $l=<MODEL1>;
}
while ( defined($l) ){
  $l=<MODEL1>;
  chomp($l);
  if (length($l)>0){
    my $min=0;
    my $gr;
    my @taus = split /\s+/, $l;
    foreach my $i(1..$#taus){
      if ($taus[$i]>$min){
	$min=$taus[$i];
	$gr=$i;
	$i++;
      }
    }
    if (! defined $classes{$taus[0]} ){
      $classes{$taus[0]}=[];
    }
    push @{ $classes{$taus[0]} }, $gr-1;
  }
}
close(MODEL1);

open(MODEL2, "<$ARGV[1]") or die "File \"$ARGV[0]\" opening problem\n";
my $l;
<MODEL2>;
my $Q = <MODEL2>;
chomp($Q);
while ($l!~/Tau/){
  $l=<MODEL2>;
}
while ( defined($l) ){
  $l=<MODEL2>;
  chomp($l);
  if (length($l)>0){
    my $min=0;
    my $gr;
    my @taus = split /\s+/, $l;
    foreach my $i(1..$#taus){
      if ($taus[$i]>$min){
	$min=$taus[$i];
	$gr=$i;
	$i++;
      }
    }
    if (! defined $classes{$taus[0]} ){
      $classes{$taus[0]}=[];
    }
    push @{ $classes{$taus[0]} }, $gr-1;
  }
}
close(MODEL2);



foreach my $id(keys%classes){
  print $id," ",$classes{$id}[0]," ",$classes{$id}[1],"\n";
}

