#!/usr/bin/perl

use strict;
if ($#ARGV < 0) {
  print "Use:\tperl $0 file.spm [--directed]\n";
  print "Goal:\tFrom a spm file to the degrees (in/out if option --directed)\n";
  exit(0);
}

open(SPM, "<$ARGV[0]") or die "File \"$ARGV[0]\" opening problem\n";
my %deg = ();
my %degout = ();
my %degin = ();
my $edg=<SPM>;
while ( defined($edg) ){
  my @vert = split /\s+/, $edg;
  $deg{$vert[0]}++;
  $deg{$vert[1]}++;
  $degout{$vert[0]}++;
  $degin{$vert[1]}++;
  $edg=<SPM>;
}

if ($ARGV[1]!~/directed/){
  print "# DEGREE\n";
  foreach my $v(sort{$a<=>$b}keys%deg){
    print "$v\t$deg{$v}\n";
  }
}
else{
  print "# OUT-DEGREE\n";
  foreach my $v(sort{$a<=>$b}keys%deg){
    if (not defined($degout{$v})){
      $degout{$v}=0;
    }
    print "$v\t$degout{$v}\n";
  }
  print "\n\n# IN-DEGREE\n";
  foreach my $v(sort{$a<=>$b}keys%deg){
    if (not defined($degin{$v})){
      $degin{$v}=0;
    }
    print "$v\t$degin{$v}\n";
  }
}
close(SPM);
